#ifndef _ECORE_AUDIO_EO_H_
#define _ECORE_AUDIO_EO_H_

/**

 */
#define ECORE_AUDIO_OBJ_CLASS ecore_audio_obj_class_get()

const Eo_Class *ecore_audio_obj_class_get(void) EINA_CONST;

/**
 * @def ecore_audio_obj_name_set
 *
 * Set the name of the object
 *
 * @since 1.8
 *
 * @param[in] name No description supplied.
 *
 */
EAPI void  ecore_audio_obj_name_set(const char *name);

/**
 * @def ecore_audio_obj_name_get
 *
 * Get the name of the object
 *
 * @since 1.8
 *
 *
 */
EAPI const char * ecore_audio_obj_name_get(void);

/**
 * @def ecore_audio_obj_paused_set
 *
 * Set the pause state of the object
 *
 * @since 1.8
 *
 * @param[in] paused No description supplied.
 *
 */
EAPI void  ecore_audio_obj_paused_set(Eina_Bool paused);

/**
 * @def ecore_audio_obj_paused_get
 *
 * Get the pause state of the object
 *
 * @since 1.8
 *
 *
 */
EAPI Eina_Bool  ecore_audio_obj_paused_get(void);

/**
 * @def ecore_audio_obj_volume_set
 *
 * Set the volume of the object
 *
 * @since 1.8
 *
 * @param[in] volume No description supplied.
 *
 */
EAPI void  ecore_audio_obj_volume_set(double volume);

/**
 * @def ecore_audio_obj_volume_get
 *
 * Get the volume of the object
 *
 * @since 1.8
 *
 *
 */
EAPI double  ecore_audio_obj_volume_get(void);

/**
 * @def ecore_audio_obj_source_set
 *
 * Set the source of the object
 *
 * What sources are supported depends on the actual object. For example,
 * the libsndfile class accepts WAV, OGG, FLAC files as source.
 *
 * @since 1.8
 *
 * @param[in] source No description supplied.
 *
 */
EAPI Eina_Bool  ecore_audio_obj_source_set(const char *source);

/**
 * @def ecore_audio_obj_source_get
 *
 * Get the source of the object
 *
 * @since 1.8
 *
 *
 */
EAPI const char * ecore_audio_obj_source_get(void);

/**
 * @def ecore_audio_obj_format_set
 *
 * Set the format of the object
 *
 * What formats are supported depends on the actual object. Default is
 * ECORE_AUDIO_FORMAT_AUTO
 *
 * @since 1.8
 *
 * @param[in] format No description supplied.
 *
 */
EAPI Eina_Bool  ecore_audio_obj_format_set(Ecore_Audio_Format format);

/**
 * @def ecore_audio_obj_format_get
 *
 * Get the format of the object
 *
 * After setting the source if the format was ECORE_AUDIO_FORMAT_AUTO this
 * function will now return the actual format.
 *
 * @since 1.8
 *
 *
 */
EAPI Ecore_Audio_Format  ecore_audio_obj_format_get(void);

/**
 * @def ecore_audio_obj_vio_set
 *
 * Set the virtual IO functions
 *
 * @since 1.8
 *
 * @param[in] vio No description supplied.
 * @param[in] data No description supplied.
 * @param[in] free_func No description supplied.
 *
 */
EAPI void  ecore_audio_obj_vio_set(Ecore_Audio_Vio *vio, void *data, eo_key_data_free_func free_func);


#endif